#include "StdAfx.h"
#include "Csdn.h"


CCsdn::CCsdn(void)
{
}


CCsdn::~CCsdn(void)
{
	for (int i=0;i<(int)_items.size();i++)
	{
		CItem* _pItem = _items.at(i);
		if(_pItem != NULL)
			delete _pItem;
		_pItem = NULL;
	}
	_items.clear();
}

CString CCsdn::ParseTag(CString _text, CString _tag_begin, CString _tag_end,CParse* _parse)
{
	int _len = strlen(_tag_begin);
	int _begin = -1;
	int _end = -1;
	if(_parse != NULL)
	{
		for(int i=0;i<_parse->_beginPosition;i++)
		{
			_begin = _text.Find(_tag_begin,_parse->_start);
			_parse->_begin = _begin;
			_parse->_beginLen = _len;
			_parse->_start = _parse->_begin+_parse->_beginLen;
		}
	}
	else
	{
		//ֱ
		_begin = _text.Find(_tag_begin);
	}
	if(_begin == -1)
		return "";
	if (_parse != NULL)
	{
		int _tempBegin = _begin + _len;
		int _end_len = strlen(_tag_end);
		for(int i=0;i<_parse->_endPosition;i++)
		{
			_end = _text.Find(_tag_end,_tempBegin);
			_tempBegin = _end + _end_len;//ʱʼλ
			_parse->_end = _end;
		}
	} 
	else
	{
		//ֱ
		_end = _text.Find(_tag_end,_begin + _len);
	}
	if (_end == -1)
		return "";
	return _text.Mid(_begin+_len,_end-_begin-_len);
}


CString CCsdn::ParseBegin(CString _text, CString _tag_begin,int pos)
{
	int _len = strlen(_tag_begin);
	int _begin = -1;
	int _start = 0;
	for (int i=0;i<pos;i++)
	{
		_begin = _text.Find(_tag_begin,_start);
		if(_begin == -1)
			return "";
		_start = _begin + _len;
	}
	return _text.Mid(_begin+_len,_text.GetLength()-_len-_begin);
}


CString CCsdn::HttpGet(CString _url,CString _charCode)
{
	CString strHtml;
	try{
		CInternetSession m_InetSession;
		CHttpFile* pFile = (CHttpFile*)m_InetSession.OpenURL(_url);
		if (pFile!=NULL)
		{
			DWORD statusCode;
			pFile->QueryInfoStatusCode(statusCode);    
			if (statusCode == HTTP_STATUS_OK)
			{
				CString strLine;
				while (pFile->ReadString(strLine)>0)
					strHtml +=  strLine;
			}
		}
		m_InetSession.Close();
		pFile->Close();
		delete pFile;
		pFile = NULL;
	}
	catch (CException* e)
	{
		TCHAR info[1024] = {0};
		e->GetErrorMessage(info,1024);
		GT_WriteReleaseLog(info);
	}
	if(_charCode == "GBK")
		ConvertUtf8ToGBK(strHtml);
	return strHtml;
}


char* CCsdn::WCharToChar(const wchar_t *wstr)
{
	//ĸ-1ʾ󳤶
	int _length = WideCharToMultiByte(CP_OEMCP, 0, wstr, -1, NULL, 0, NULL, FALSE);
	char *pstr = new char[_length+1];
	_length = WideCharToMultiByte(CP_OEMCP, 0, wstr, -1, pstr, _length, NULL, FALSE);
	pstr[_length] = 0;
	return pstr;
}

wchar_t* CCsdn::CharToWChar(const char *str)
{
	//ĸ-1ʾ󳤶
	int _length = MultiByteToWideChar(CP_ACP, 0, str, -1, NULL, 0);
	wchar_t *pwText = new wchar_t[_length+1];
	_length = MultiByteToWideChar(CP_ACP,0,str,-1,pwText,_length);
	pwText[_length] = 0;
	return pwText;
}

void CCsdn::ConvertGBKToUtf8(CString& strGBK)
{
	int len = MultiByteToWideChar(CP_ACP, 0, strGBK, -1, NULL,0);
	WCHAR* wszUtf8 = new WCHAR[len+1];
	MultiByteToWideChar(CP_ACP, 0, strGBK, -1, wszUtf8, len);

	len = WideCharToMultiByte(CP_UTF8, 0, wszUtf8, -1, NULL, 0, NULL, NULL); 
	char* szUtf8 = new char[len + 1];
	WideCharToMultiByte (CP_UTF8, 0, wszUtf8, -1, szUtf8, len, NULL,NULL);

	strGBK = szUtf8;
	delete szUtf8;
	szUtf8 = NULL;
	delete wszUtf8;
	wszUtf8 = NULL;
}

void CCsdn::ConvertUtf8ToGBK(CString& strUtf8)
{
	int len = MultiByteToWideChar(CP_UTF8, 0, strUtf8, -1, NULL,0);
	WCHAR* wszGBK = new WCHAR[len+1];
	MultiByteToWideChar(CP_UTF8, 0, strUtf8, -1, wszGBK, len);
	len = WideCharToMultiByte(CP_ACP, 0, wszGBK, -1, NULL, 0, NULL, NULL); 
	char* szGBK = new char[len + 1];
	WideCharToMultiByte (CP_ACP, 0, wszGBK, -1, szGBK, len, NULL,NULL);

	strUtf8 = szGBK;
	delete szGBK;
	szGBK = NULL;
	delete wszGBK;
	wszGBK = NULL;
}
// б
void CCsdn::ParseList(CString _text)
{
	const char* tag_td_begin = "<td class=\"title\">";
	const char* tag_td_end = "</td>";
	CParse parse;
	parse._endPosition = 4;//ҵڶγtag_td_endλý
	CString _td = ParseTag(_text,tag_td_begin,tag_td_end,&parse);
	while(parse.hasNext())
	{
		CString title = ParseTag(_td,"title=\"","\"");
		CString href = ParseTag(_td,"href=\"","\"");
		int reply = atoi(ParseBegin(_td,"<td class=\"tc\">",3));
		CItem* pItem = new CItem;
		pItem->_title = title;
		pItem->_title.Replace("\\","\\\\");
		pItem->_title.Replace("'","");//滻ΪԲ
		pItem->SetUrl(href);
		pItem->_reply = reply;
		_items.push_back(pItem);
		_td = ParseTag(_text,tag_td_begin,tag_td_end,&parse);
	}
}

// ҳ,ȡͲȡĴ
bool CCsdn::ParseQuestion(CString _text,CItem* _item)
{
	if (_item != NULL)
		_item->Clear();
	bool b = false;
	CParse parse;
	CParse parseFirst;
	parseFirst._endPosition = 2;//ҵڶγֵ"</div>"
	//ȽTDǩȡ÷ݺͻظ
	CString _td = ParseTag(_text,"<div class=\"post_body\">","<div id='topic-extra-info'>",&parse);
	//;
	_item->_question = ParseBegin(_td,"</div>");// <div class="tag">
	_item->_question.Replace("\\","\\\\");
	_item->_question.Replace("'","");//滻ΪԲ
	while(parse.hasNext())
	{
		//TDǩ
		_td = ParseTag(_text,"<td valign=\"top\"","</td>",&parse);
		//ظ
		CString _score = ParseTag(_td,"÷֣","</span>");
		CString _content = ParseTag(_td,"<div class=\"post_body\">","</div>");
		CAnswer* _answer = new CAnswer;
		_answer->_text = _content;
		_answer->_text.Replace("\\","\\\\");//ת'\'
		_answer->_text.Replace("'","");//滻ΪԲ
		_answer->_score = atoi(_score);
		if (_item != NULL)
		{
			_item->_answer.push_back(_answer);
			b = true;
		}
	}
	return b;
}

