#include "StdAfx.h"
#include "Item.h"

#define CSDN_BBS_DOMAIN "http://bbs.csdn.net"

CItem::CItem(void)
{
	_reply = 0;
	_cid = 0;
	_pid = 0;
}


CItem::~CItem(void)
{
	//vectorָɾȻNULLٴγҰָ
}

void CItem::SetUrl(CString url)
{
	bool b = false;
	if(url.GetLength()>4)
	{
		CString left = url.Left(4);
		if(strcmp(left,"http") == 0)
			b = true;
	}
	if(b)
		this->_url = url;
	else
		this->_url = CSDN_BBS_DOMAIN + url;
}

CString CItem::toString()
{
	CString text;
	text += _title;
	text += " | ";
	text += _url;
	text += " | ";
	char tmp[10];
	sprintf_s(tmp,"%d",_reply);
	text += tmp;
	text += " |  ";
	memset(tmp,0,sizeof(tmp));
	sprintf_s(tmp,"%d",_type);
	text += tmp;
	text += " |  \n:\n";
	text += _question;
	text += "\n\n\nظ:\n";
	int _size = _answer.size();
	for (int i=0;i<_size;i++)
	{
		CAnswer* answer = _answer.at(i);
		if(answer != NULL && answer->_text.GetLength() > 0)
		{
			text += "\n--------------------begin-----------------\n";
			text += answer->_text;
			text += "\n--------------------end-----------------\n";
		}
	}
	text += "\n";
	return text;
}


void CItem::Clear(void)
{
	int _size = _answer.size();
	for (int i=0;i<_size;i++)
	{
		CAnswer* answer = _answer.at(i);
		if(answer != NULL)
			delete answer;
		answer = NULL;
	}
	_answer.clear();
}
