#include "StdAfx.h"
#include "MysqlHelper.h"

CMysqlHelper* CMysqlHelper::pHelper = NULL;

CMysqlHelper::CMysqlHelper(void)
{
	m_connected = false;
}


CMysqlHelper::~CMysqlHelper(void)
{
	if(m_connected)
		mysql_close(&m_mysql);
	m_connected = false;
}


bool CMysqlHelper::init(char* _host,char* _base,char* _user,char* _pwd)
{
	mysql_init(&m_mysql);
	if (!mysql_real_connect(&m_mysql,_host,_user,_pwd,_base,3306,NULL,0))
	{
		mysql_errno(&m_mysql);//ӳ
		const char* error = mysql_error(&m_mysql);
		AfxMessageBox(error);
		return false;
	}
	else
	{
		m_connected = true;
		//ñʽ,cmd޷ʾ 
		mysql_query(&m_mysql,"SET NAMES GBK");
		return true;
	}
}

void CMysqlHelper::query(char* sql,vector<CStringArray*> &_result)
{
	if (!excute(sql))
	{
		AfxMessageBox("ѯʧ");
		return;
	}
	m_res = mysql_store_result(&m_mysql);//ѯݵresult
	if (m_res != NULL)
	{
		//TRACE("\n\n");
		//while((m_fd = mysql_fetch_field(m_res)))
		//	TRACE("%s ",m_fd->name);//ֵ
		//TRACE("\n");
		int nColumn = mysql_num_fields(m_res);//ȡе
		while((m_row = mysql_fetch_row(m_res)))
		{
			CStringArray* arrays = new CStringArray;
			int nIndex = 0;
			while(nIndex < nColumn)
			{
				arrays->Add(CString(m_row[nIndex]));
				//TRACE("%s ",m_row[nIndex]);
				nIndex++;
			}
			_result.push_back(arrays);
		}
	}
	mysql_free_result(m_res);
}


void CMysqlHelper::insert(char* sql)
{
	if (!excute(sql))
	{
		AfxMessageBox("дʧ");
		return;
	}
}


bool CMysqlHelper::excute(char* sql)
{
	if(!m_connected)
	{
		AfxMessageBox("ݿδʼ!");
		return false;
	}
	bool _ok = mysql_query(&m_mysql,sql) == 0;
	if(!_ok)
	{
		 const char* _error = mysql_error(&m_mysql);
		 GT_WriteReleaseLog("----------־----------");
		 GT_WriteReleaseLog(_error);
	}
	return _ok;
}

CMysqlHelper* CMysqlHelper::getInstance()
{
	if(pHelper == NULL)
		pHelper = new CMysqlHelper;
	return pHelper;
}

void CMysqlHelper::close(void)
{
	if(pHelper != NULL)
		delete pHelper;
	pHelper = NULL;
}


bool CMysqlHelper::isConnected(void)
{
	return this->m_connected;
}
