#pragma once

#include <mysql.h>
#include <vector>

#pragma comment(lib,"libmysql.lib")

using namespace std;

class CMysqlHelper
{
public:
	bool m_connected;
	MYSQL m_mysql;
	MYSQL_RES *m_res;
	MYSQL_ROW m_row;
	MYSQL_FIELD *m_fd;
	CMysqlHelper(void);
	~CMysqlHelper(void);
	bool init(char* _host,char* _base,char* _user,char* _pwd);
	void query(char* sql,vector<CStringArray*> &_result);
	void insert(char* sql);
	bool excute(char* sql);
	static CMysqlHelper* getInstance();
private:
	static CMysqlHelper* pHelper;
public:
	void close(void);
	bool isConnected(void);
};

